Index: trunk/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_bilap.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_bilap.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_bilap.F90	(revision 2528)
@@ -2,5 +2,16 @@
    !!==============================================================================
    !!                   ***  MODULE  traldf_bilap  ***
-   !! Ocean active tracers:  horizontal component of the lateral tracer mixing trend
+   !! Ocean  tracers:  horizontal component of the lateral tracer mixing trend
+   !!==============================================================================
+   !! History :  OPA  !  1991-11  (G. Madec)  Original code
+   !!                 !  1993-03  (M. Guyon)  symetrical conditions
+   !!                 !  1995-11  (G. Madec)  suppress volumetric scale factors
+   !!                 !  1996-01  (G. Madec)  statement function for e3
+   !!                 !  1996-01  (M. Imbard)  mpp exchange
+   !!                 !  1997-07  (G. Madec)  optimization, and ahtt
+   !!            8.5  !  2002-08  (G. Madec)  F90: Free form and module
+   !!   NEMO     1.0  !  2004-08  (C. Talandier) New trends organization
+   !!             -   !  2005-11  (G. Madec)  zps or sco as default option
+   !!            3.3  !  2010-05  (C. Ethe, G. Madec)  merge TRC-TRA 
    !!==============================================================================
 
@@ -9,21 +20,17 @@
    !!                   using a iso-level biharmonic operator
    !!----------------------------------------------------------------------
-   !! * Modules used
    USE oce             ! ocean dynamics and active tracers
    USE dom_oce         ! ocean space and time domain
    USE ldftra_oce      ! ocean tracer   lateral physics
-   USE trdmod          ! ocean active tracers trends 
-   USE trdmod_oce      ! ocean variables trends
    USE in_out_manager  ! I/O manager
    USE ldfslp          ! iso-neutral slopes 
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
    USE diaptr          ! poleward transport diagnostics
-   USE prtctl          ! Print control
+   USE trc_oce         ! share passive tracers/Ocean variables
 
    IMPLICIT NONE
    PRIVATE
 
-   !! * Routine accessibility
-   PUBLIC tra_ldf_bilap   ! routine called by step.F90
+   PUBLIC   tra_ldf_bilap   ! routine called by step.F90
 
    !! * Substitutions
@@ -33,21 +40,21 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2005) 
-   !! $Id$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! $Id$
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-
 CONTAINS
-   
-   SUBROUTINE tra_ldf_bilap( kt )
+ 
+   SUBROUTINE tra_ldf_bilap( kt, cdtype, pgu, pgv,      &
+      &                                  ptb, pta, kjpt )  
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE tra_ldf_bilap  ***
       !!
-      !! ** Purpose :   Compute the before horizontal tracer (t & s) diffusive 
+      !! ** Purpose :   Compute the before horizontal tracer diffusive 
       !!      trend and add it to the general trend of tracer equation.
       !!
       !! ** Method  :   4th order diffusive operator along model level surfaces 
       !!      evaluated using before fields (forward time scheme). The hor.
-      !!      diffusive trends of temperature (idem for salinity) is given by:
+      !!      diffusive trends  is given by:
       !!      Laplacian of tb:
       !!         zlt   = 1/(e1t*e2t*e3t) {  di-1[ e2u*e3u/e1u di(tb) ]
@@ -59,167 +66,98 @@
       !!         difft = 1/(e1t*e2t*e3t) {  di-1[ e2u*e3u/e1u di(zlt) ]
       !!                                  + dj-1[ e1v*e3v/e2v dj(zlt) ]  }
-      !!      Note: if key_zco defined, e3t=e3u=e3v, they are simplified.
       !!
-      !!      Add this trend to the general trend (ta,sa):
-      !!         (ta,sa) = (ta,sa) + ( difft , diffs )
+      !!      Add this trend to the general trend
+      !!         (pta) = (pta) + ( difft )
       !!
-      !! ** Action : - Update (ta,sa) arrays with the before iso-level
+      !! ** Action : - Update pta arrays with the before iso-level
       !!               biharmonic mixing trend.
+      !!----------------------------------------------------------------------
+      USE oce         , ztu => ua   ! use ua as workspace
+      USE oce         , ztv => va   ! use va as workspace
       !!
-      !! History :
-      !!        !  91-11  (G. Madec)  Original code
-      !!        !  93-03  (M. Guyon)  symetrical conditions
-      !!        !  95-11  (G. Madec)  suppress volumetric scale factors
-      !!        !  96-01  (G. Madec)  statement function for e3
-      !!        !  96-01  (M. Imbard)  mpp exchange
-      !!        !  97-07  (G. Madec)  optimization, and ahtt
-      !!   8.5  !  02-08  (G. Madec)  F90: Free form and module
-      !!   9.0  !  04-08  (C. Talandier) New trends organization
-      !!        !  05-11  (G. Madec)  zps or sco as default option
-      !!----------------------------------------------------------------------
-      !! * Modules used
-      USE oce           , ztu => ua,  &  ! use ua as workspace
-         &                ztv => va      ! use va as workspace
-
-      !! * Arguments
-      INTEGER, INTENT( in ) ::   kt       ! ocean time-step index
-
-      !! * Local declarations
-      INTEGER ::   ji, jj, jk             ! dummy loop indices
-      INTEGER ::   iku, ikv               ! temporary integers
-      REAL(wp) ::   zta, zsa              ! temporary scalars
-      REAL(wp), DIMENSION(jpi,jpj) ::   & 
-         zeeu, zeev, zbtr,              & ! 2D workspace
-         zlt, zls
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   & 
-         zsu, zsv                         ! 3D workspace 
+      INTEGER                              , INTENT(in   ) ::   kt         ! ocean time-step index
+      CHARACTER(len=3)                     , INTENT(in   ) ::   cdtype     ! =TRA or TRC (tracer indicator)
+      INTEGER                              , INTENT(in   ) ::   kjpt       ! number of tracers
+      REAL(wp), DIMENSION(jpi,jpj,    kjpt), INTENT(in   ) ::   pgu, pgv   ! tracer gradient at pstep levels
+      REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(in   ) ::   ptb        ! before and now tracer fields
+      REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(inout) ::   pta        ! tracer trend 
+      !!
+      INTEGER  ::  ji, jj, jk, jn   ! dummy loop indices
+      REAL(wp) ::  zbtr, ztra       ! local scalars
+      REAL(wp), DIMENSION(jpi,jpj) ::   zeeu, zeev, zlt   ! 2D workspace
       !!----------------------------------------------------------------------
 
-      IF( kt == nit000 ) THEN
+      IF( kt == nit000 )  THEN
          IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'tra_ldf_bilap : iso-level biharmonic operator'
+         IF(lwp) WRITE(numout,*) 'tra_ldf_bilap : iso-level biharmonic operator on ', cdtype
          IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~~'
       ENDIF
-
-
-      !                                                ! ===============
-      DO jk = 1, jpkm1                                 ! Horizontal slab
-         !                                             ! ===============
-
-         ! 0. Initialization of metric arrays (for z- or s-coordinates)
-         ! ----------------------------------
-
-         IF( lk_zco ) THEN      ! z-coordinate (1D arrays): no vertical scale factors
+      !                                                          ! ===========
+      DO jn = 1, kjpt                                            ! tracer loop
+         !                                                       ! ===========
+         !                                               
+         DO jk = 1, jpkm1                                        ! Horizontal slab
+            !                                             
+            !                          !==  Initialization of metric arrays (for z- or s-coordinates)  ==!
             DO jj = 1, jpjm1
                DO ji = 1, fs_jpim1   ! vector opt.
-                  zbtr(ji,jj) = 1. / ( e1t(ji,jj)*e2t(ji,jj) )
-                  zeeu(ji,jj) = e2u(ji,jj) / e1u(ji,jj) * umask(ji,jj,jk)
-                  zeev(ji,jj) = e1v(ji,jj) / e2v(ji,jj) * vmask(ji,jj,jk)
-               END DO
-            END DO
-         ELSE                   ! All coordinates (3D arrays): vertical scale factor are used
-            DO jj = 1, jpjm1
-               DO ji = 1, fs_jpim1   ! vector opt.
-                  zbtr(ji,jj) = 1. / ( e1t(ji,jj)*e2t(ji,jj)*fse3t(ji,jj,jk) )
                   zeeu(ji,jj) = e2u(ji,jj) * fse3u(ji,jj,jk) / e1u(ji,jj) * umask(ji,jj,jk)
                   zeev(ji,jj) = e1v(ji,jj) * fse3v(ji,jj,jk) / e2v(ji,jj) * vmask(ji,jj,jk)
                END DO
             END DO
-         ENDIF
 
-
-         ! 1. Laplacian
-         ! ------------
-
-         ! First derivative (gradient)
-         DO jj = 1, jpjm1
-            DO ji = 1, fs_jpim1   ! vector opt.
-               ztu(ji,jj,jk) = zeeu(ji,jj) * ( tb(ji+1,jj  ,jk) - tb(ji,jj,jk) )
-               zsu(ji,jj,jk) = zeeu(ji,jj) * ( sb(ji+1,jj  ,jk) - sb(ji,jj,jk) )
-               ztv(ji,jj,jk) = zeev(ji,jj) * ( tb(ji  ,jj+1,jk) - tb(ji,jj,jk) )
-               zsv(ji,jj,jk) = zeev(ji,jj) * ( sb(ji  ,jj+1,jk) - sb(ji,jj,jk) )
-            END DO
-         END DO
-         IF( ln_zps ) THEN      ! set gradient at partial step level
-            DO jj = 1, jpjm1
-               DO ji = 1, jpim1
-                  ! last level
-                  iku = MIN ( mbathy(ji,jj), mbathy(ji+1,jj  ) ) - 1
-                  ikv = MIN ( mbathy(ji,jj), mbathy(ji  ,jj+1) ) - 1
-                  IF( iku == jk ) THEN
-                     ztu(ji,jj,jk) = zeeu(ji,jj) * gtu(ji,jj)
-                     zsu(ji,jj,jk) = zeeu(ji,jj) * gsu(ji,jj)
-                  ENDIF
-                  IF( ikv == jk ) THEN
-                     ztv(ji,jj,jk) = zeev(ji,jj) * gtv(ji,jj)
-                     zsv(ji,jj,jk) = zeev(ji,jj) * gsv(ji,jj)
-                  ENDIF
+            !                          !==  Laplacian  ==!
+            !
+            DO jj = 1, jpjm1                 ! First derivative (gradient)
+               DO ji = 1, fs_jpim1   ! vector opt.
+                  ztu(ji,jj,jk) = zeeu(ji,jj) * ( ptb(ji+1,jj  ,jk,jn) - ptb(ji,jj,jk,jn) )
+                  ztv(ji,jj,jk) = zeev(ji,jj) * ( ptb(ji  ,jj+1,jk,jn) - ptb(ji,jj,jk,jn) )
                END DO
             END DO
-         ENDIF
-
-         ! Second derivative (divergence)
-         DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1   ! vector opt.
-               zlt(ji,jj) = zbtr(ji,jj) * (  ztu(ji,jj,jk) - ztu(ji-1,jj,jk) + ztv(ji,jj,jk) - ztv(ji,jj-1,jk)  )
-               zls(ji,jj) = zbtr(ji,jj) * (  zsu(ji,jj,jk) - zsu(ji-1,jj,jk) + zsv(ji,jj,jk) - zsv(ji,jj-1,jk)  )
-            END DO
-         END DO
-
-         ! Multiply by the eddy diffusivity coefficient
-         DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1   ! vector opt.
-               zlt(ji,jj) = fsahtt(ji,jj,jk) * zlt(ji,jj)
-               zls(ji,jj) = fsahtt(ji,jj,jk) * zls(ji,jj)
-            END DO
-         END DO
-
-         ! Lateral boundary conditions on the laplacian (zlt,zls)   (unchanged sgn)
-         CALL lbc_lnk( zlt, 'T', 1. )   ;    CALL lbc_lnk( zls, 'T', 1. )
-
-         ! 2. Bilaplacian
-         ! --------------
-
-         ! third derivative (gradient)
-         DO jj = 1, jpjm1
-            DO ji = 1, fs_jpim1   ! vector opt.
-               ztu(ji,jj,jk) = zeeu(ji,jj) * ( zlt(ji+1,jj  ) - zlt(ji,jj) )
-               zsu(ji,jj,jk) = zeeu(ji,jj) * ( zls(ji+1,jj  ) - zls(ji,jj) )
-               ztv(ji,jj,jk) = zeev(ji,jj) * ( zlt(ji  ,jj+1) - zlt(ji,jj) )
-               zsv(ji,jj,jk) = zeev(ji,jj) * ( zls(ji  ,jj+1) - zls(ji,jj) )
-            END DO
-         END DO
-
-         ! fourth derivative (divergence) and add to the general tracer trend
-         DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1   ! vector opt.
-               ! horizontal diffusive trends
-               zta = zbtr(ji,jj) * (  ztu(ji,jj,jk) - ztu(ji-1,jj,jk) + ztv(ji,jj,jk) - ztv(ji,jj-1,jk)  )
-               zsa = zbtr(ji,jj) * (  zsu(ji,jj,jk) - zsu(ji-1,jj,jk) + zsv(ji,jj,jk) - zsv(ji,jj-1,jk)  )
-               ! add it to the general tracer trends
-               ta(ji,jj,jk) = ta(ji,jj,jk) + zta
-               sa(ji,jj,jk) = sa(ji,jj,jk) + zsa
-            END DO
-         END DO
-         !                                             ! ===============
-      END DO                                           ! Horizontal slab
-      !                                                ! ===============
-
-      ! "zonal" mean lateral diffusive heat and salt transport
-      IF( ln_diaptr .AND. ( MOD( kt, nf_ptr ) == 0 ) ) THEN
-         IF( lk_zco ) THEN      ! z-coordinate (1D arrays): multiply by the vertical scale factor
-            DO jk = 1, jpkm1
-               DO jj = 2, jpjm1
-                  DO ji = fs_2, fs_jpim1   ! vector opt.
-                     ztv(ji,jj,jk) = ztv(ji,jj,jk) * fse3v(ji,jj,jk)
-                     zsv(ji,jj,jk) = zsv(ji,jj,jk) * fse3v(ji,jj,jk)
+            IF( ln_zps ) THEN                ! set gradient at partial step level (last ocean level)
+               DO jj = 1, jpjm1
+                  DO ji = 1, jpim1
+                     IF( mbku(ji,jj) == jk )  ztu(ji,jj,jk) = zeeu(ji,jj) * pgu(ji,jj,jn)
+                     IF( mbkv(ji,jj) == jk )  ztv(ji,jj,jk) = zeev(ji,jj) * pgv(ji,jj,jn)
                   END DO
                END DO
+            ENDIF
+            DO jj = 2, jpjm1                 ! Second derivative (divergence) time the eddy diffusivity coefficient
+               DO ji = fs_2, fs_jpim1   ! vector opt.
+                  zbtr = 1.0 / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
+                  zlt(ji,jj) = fsahtt(ji,jj,jk) * zbtr * (   ztu(ji,jj,jk) - ztu(ji-1,jj,jk)   &
+                     &                                     + ztv(ji,jj,jk) - ztv(ji,jj-1,jk)   )
+               END DO
             END DO
+            CALL lbc_lnk( zlt, 'T', 1. )     ! Lateral boundary conditions (unchanged sgn)
+
+            !                          !==  Bilaplacian  ==!
+            !
+            DO jj = 1, jpjm1                 ! third derivative (gradient)
+               DO ji = 1, fs_jpim1   ! vector opt.
+                  ztu(ji,jj,jk) = zeeu(ji,jj) * ( zlt(ji+1,jj  ) - zlt(ji,jj) )
+                  ztv(ji,jj,jk) = zeev(ji,jj) * ( zlt(ji  ,jj+1) - zlt(ji,jj) )
+               END DO
+            END DO
+            DO jj = 2, jpjm1                 ! fourth derivative (divergence) and add to the general tracer trend
+               DO ji = fs_2, fs_jpim1   ! vector opt.
+                  ! horizontal diffusive trends
+                  zbtr = 1.0 / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
+                  ztra = zbtr * (  ztu(ji,jj,jk) - ztu(ji-1,jj,jk) + ztv(ji,jj,jk) - ztv(ji,jj-1,jk)  )
+                  ! add it to the general tracer trends
+                  pta(ji,jj,jk,jn) = pta(ji,jj,jk,jn) + ztra
+               END DO
+            END DO
+            !                                             
+         END DO                                           ! Horizontal slab
+         !                                                
+         ! "zonal" mean lateral diffusive heat and salt transport
+         IF( cdtype == 'TRA' .AND. ln_diaptr .AND. ( MOD( kt, nn_fptr ) == 0 ) ) THEN  
+           IF( jn == jp_tem )  htr_ldf(:) = ptr_vj( ztv(:,:,:) )
+           IF( jn == jp_sal )  str_ldf(:) = ptr_vj( ztv(:,:,:) )
          ENDIF
-         pht_ldf(:) = ptr_vj( ztv(:,:,:) )
-         pst_ldf(:) = ptr_vj( zsv(:,:,:) )
-      ENDIF
-
+         !                                                ! ===========
+      END DO                                              ! tracer loop
+      !                                                   ! ===========
    END SUBROUTINE tra_ldf_bilap
 
